FROM archlinux:latest

LABEL name="docker-arm-toolchain"
LABEL vendor="Silesian Aerospace Technologies"
LABEL summary="Arch Linux based gcc-arm-none-eabi (13.2.1-1.1) toolchain with CMake and other utils."

ARG INSTALL_PATH=/opt

ARG TOOLCHAIN_URL=https://github.com/xpack-dev-tools/arm-none-eabi-gcc-xpack/releases/download/v13.2.1-1.1/xpack-arm-none-eabi-gcc-13.2.1-1.1-linux-x64.tar.gz
ARG TOOLCHAIN_NAME=xpack-arm-none-eabi-gcc-13.2.1-1.1

ARG SONAR_SCANNER_VERSION=sonar-scanner-5.0.1.3006-linux
ARG SONAR_SCANNER_URL=https://binaries.sonarsource.com/Distribution/sonar-scanner-cli/sonar-scanner-cli-5.0.1.3006-linux.zip

ARG SONAR_HOST_URL=https://sonarcloud.io
ARG BUILD_WRAPPER_VERSION=build-wrapper-linux-x86.zip
ARG BUILD_WRAPPER_URL=${SONAR_HOST_URL}/static/cpp/${BUILD_WRAPPER_VERSION}

ARG QEMU_URL=https://gitlab.com/api/v4/projects/33158668/jobs/artifacts/sat-master-8/raw/qemu-system-arm?job=amd64-qemu-system-arm-linux-container

COPY ./tools/* ${INSTALL_PATH}/tools/

RUN chmod -R 777 ${INSTALL_PATH}/tools

RUN pacman-key --init

RUN pacman -Syu --noconfirm

RUN pacman-key --refresh-keys

RUN pacman -Syu --noconfirm \
        gcc \
        clang \
        make \
        cmake \
        python \
        python-pip \
        git doxygen \
        wget \
        unzip \
        pixman \
        dtc \
        ninja \
        gdb \
        jq \
        gcovr \
        capstone \
        libpng \
        rdma-core \
        libslirp \
        sndio \
        liburing

# Libbpf workaround
ARG LIBBPF=libbpf-0.8.1-1-x86_64.pkg.tar.zst
ARG LIBBPF_URL=https://archive.archlinux.org/packages/l/libbpf/libbpf-0.8.1-1-x86_64.pkg.tar.zst
RUN wget -O ${LIBBPF} ${LIBBPF_URL} \
    && pacman -U --noconfirm ${LIBBPF} \
    && rm ${LIBBPF}

# Install the toolchain
RUN wget -O ${TOOLCHAIN_NAME}.tar.gz ${TOOLCHAIN_URL} \
    && tar xf ${TOOLCHAIN_NAME}.tar.gz -C ${INSTALL_PATH} \
    && rm ${TOOLCHAIN_NAME}.tar.gz

# Install the sonar-scanner
RUN curl -sSLo sonar-scanner.zip ${SONAR_SCANNER_URL} \
    && unzip -o sonar-scanner.zip \
    && mv ${SONAR_SCANNER_VERSION} ${INSTALL_PATH}/sonar-scanner

# Install the build-wrapper
RUN curl -sSLo ${BUILD_WRAPPER_VERSION} ${BUILD_WRAPPER_URL} \
    && unzip -oj ${BUILD_WRAPPER_VERSION} -d ${INSTALL_PATH}/build-wrapper

RUN curl --create-dirs -sSLo ${INSTALL_PATH}/qemu/qemu-system-arm ${QEMU_URL} \
    && chmod +x ${INSTALL_PATH}/qemu/qemu-system-arm 

# Add toolchain and sonar binaries to PATH
ENV PATH="${INSTALL_PATH}/${TOOLCHAIN_NAME}/bin:${INSTALL_PATH}/build-wrapper:${INSTALL_PATH}/sonar-scanner/bin:${INSTALL_PATH}/qemu:${INSTALL_PATH}/tools:${PATH}"
